package nc.bs.pub.action;

import java.util.ArrayList;
import java.util.Hashtable;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.ml.NCLangResOnserver;
import nc.bs.pub.compiler.AbstractCompiler2;
import nc.bs.scm.plugin.InvokeEventProxy;
import nc.bs.so.outer.SOBusitransBO;
import nc.itf.po.IOrder;
import nc.itf.scm.so.outer.ISaleOrderInterface;
import nc.itf.so.so120.IBillInvokeCreditManager;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.sf.ICreateCorpQueryService;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.outer.BusiTransVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.pub.lang.UFDouble;
import nc.vo.scm.plugin.Action;
import nc.vo.so.credit.SOCreditPara;
import nc.vo.so.so001.SaleOrderVO;
import nc.vo.so.so001.SaleorderBVO;
import nc.vo.so.so001.SaleorderHVO;
import nc.vo.uap.pf.PFBusinessException;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;

public class N_30_SoBlankout extends AbstractCompiler2 {
	private Hashtable m_methodReturnHas = new Hashtable();
	private Hashtable m_keyHas = null;
	private static IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);

	public Object runComClass(PfParameterVO vo) throws BusinessException {
		try {
			super.m_tmpVo = vo;
			Object inObject = this.getVo();
			if (!(inObject instanceof SaleOrderVO)) {
				throw new BusinessException(NCLangResOnserver.getInstance().getStrByID("sopub", "UPPsopub-000258"));
			} else if (inObject == null) {
				throw new BusinessException(NCLangResOnserver.getInstance().getStrByID("sopub", "UPPsopub-000259"));
			} else {
				SaleOrderVO inVO = (SaleOrderVO) inObject;
				String pk_bill = ((SaleorderHVO) inVO.getParentVO()).getCsaleid();
				String billtype = ((SaleorderHVO) inVO.getParentVO()).getCreceipttype();
				inObject = null;
				Integer iAct = new Integer(2);
				this.setParameter("iAction", iAct);
				String sActionMsg = "";
				this.setParameter("ACTIONMSG", sActionMsg);
				this.setParameter("INVO", inVO);
				this.setParameter("PKBILL", pk_bill);
				this.setParameter("BILLTYPE", billtype);
				Object retObj = null;
				this.runClass("nc.impl.scm.so.pub.DataControlDMO", "lockPkForVo",
						"&INVO:nc.vo.pub.AggregatedValueObject", vo, this.m_keyHas, this.m_methodReturnHas);
				if (retObj != null) {
					this.m_methodReturnHas.put("lockPkForVo", retObj);
				}

				try {
					this.runClass("nc.impl.scm.so.pub.ParallelCheckDMO", "checkVoNoChanged",
							"&INVO:nc.vo.pub.AggregatedValueObject", vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("checkVoNoChanged", retObj);
					}

					retObj = this.runClass("nc.impl.scm.so.pub.CheckStatusDMO", "isDelStatus",
							"&INVO:nc.vo.pub.AggregatedValueObject", vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("isEditStatus", retObj);
					}

					ICreateCorpQueryService corpService = (ICreateCorpQueryService) NCLocator.getInstance()
							.lookup(ICreateCorpQueryService.class.getName());
					boolean creditEnabled = corpService.isEnabled(inVO.getPk_corp(), "SO6");
					Object creditObject = null;
					Object creditPara = null;
					if (creditEnabled) {
						IBillInvokeCreditManager creditManager = (IBillInvokeCreditManager) NCLocator.getInstance()
								.lookup(IBillInvokeCreditManager.class.getName());
						SOCreditPara para = new SOCreditPara(new String[]{inVO.getPrimaryKey()}, (String[]) null, 2,
								new String[]{inVO.getBizTypeid()}, inVO.getPk_corp(), creditManager);
						creditObject = creditManager;
						creditPara = para;
						creditManager.renovateARByHidsBegin(para);
					}

					InvokeEventProxy eventproxy = new InvokeEventProxy("SO", "30");
					eventproxy.beforeAction(Action.DELETE, new AggregatedValueObject[]{inVO}, (Object) null);
					BusiTransVO[] busiTransVOs;
					try {
						SOBusitransBO bo = new SOBusitransBO();
						busiTransVOs = bo.getBusiTransVO("del", "30");
						if (busiTransVOs != null && busiTransVOs.length > 0) {
							for (int i = 0; i < busiTransVOs.length; ++i) {
								((ISaleOrderInterface) ((ISaleOrderInterface) busiTransVOs[i].getInfClass()))
										.beforeDelete(inVO);
							}
						}
					} catch (Exception var21) {
						throw new BusinessException("二次开发外部接口 销售订单删除前操作出现问题！" + var21.getMessage(), var21.getCause());
					}

					Integer istatus = (Integer) inVO.getParentVO().getAttributeValue("fstatus");
					ArrayList listatpbefore = null;
					if (istatus != null && istatus != 8 && inVO != null && inVO.getBodyVOs() != null
							&& inVO.getBodyVOs().length > 0) {
						this.setParameter("ATPVO", inVO);
						listatpbefore = (ArrayList) this.runClass("nc.impl.so.sointerface.SOATP", "modifyATPBefore",
								"&ATPVO:nc.vo.pub.AggregatedValueObject", vo, this.m_keyHas, this.m_methodReturnHas);
					}

					this.runClass("nc.impl.scm.so.pub.OtherInterfaceDMO", "setSaleCT",
							"&INVO:nc.vo.pub.AggregatedValueObject", vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("setSaleCT", retObj);
					}

					this.runClass("nc.impl.scm.so.so001.SaleOrderDMO", "setPreOrdStatus",
							"&INVO:nc.vo.pub.AggregatedValueObject", vo, this.m_keyHas, this.m_methodReturnHas);
					retObj = this.runClass("nc.impl.scm.so.pub.BusinessControlDMO", "setBillBlankOut",
							"&PKBILL:String,&BILLTYPE:String", vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("setBillBlankOut", retObj);
					}

					retObj = this.runClass("nc.impl.scm.so.pub.CheckValueValidityImpl", "returnBillCodeNoNewTrans",
							"&INVO:nc.vo.pub.AggregatedValueObject", vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("returnBillNo", retObj);
					}

					retObj = this.runClass("nc.impl.scm.so.so016.BalanceDMO", "updateSoBalanceWhenOrdBlankout",
							"&INVO:nc.vo.so.so001.SaleOrderVO", vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("updateSoBalanceWhenOrdBlankout", retObj);
					}

					this.runClass("nc.impl.scm.so.so001.SaleOrderDMO", "setRetNum", "&INVO:nc.vo.so.so001.SaleOrderVO",
							vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("setRetNum", retObj);
					}

					this.runClass("nc.impl.scm.so.so008.OosinfoDMO", "blankFromOrder",
							"&INVO:nc.vo.so.so001.SaleOrderVO", vo, this.m_keyHas, this.m_methodReturnHas);
					if (retObj != null) {
						this.m_methodReturnHas.put("blankFromOrder", retObj);
					}

					String sButtonName;
					if (inVO.getHeadVO().isCoopped()) {
						sButtonName = inVO.getBodyVOs()[0].getCsourcebillid();
						this.reWritePO(new String[]{sButtonName}, false);
					}

					if (istatus != null && istatus != 8 && inVO != null && inVO.getBodyVOs() != null
							&& inVO.getBodyVOs().length > 0) {
						this.setParameter("LISTATPBEFORE", listatpbefore);
						this.runClass("nc.impl.so.sointerface.SOATP", "modifyATPAfter",
								"&ATPVO:nc.vo.pub.AggregatedValueObject,&LISTATPBEFORE:java.util.ArrayList", vo,
								this.m_keyHas, this.m_methodReturnHas);
					}

					sButtonName = NCLangResOnserver.getInstance().getStrByID("common", "UC001-0000039");
					inVO.insertOperLog(inVO, sActionMsg, this.getOperator(), sButtonName);
					if (retObj != null) {
						this.m_methodReturnHas.put("insertBusinesslog", retObj);
					}

					if (creditEnabled) {
						IBillInvokeCreditManager creditManager = (IBillInvokeCreditManager) creditObject;
						creditManager.renovateARByHidsEnd((SOCreditPara) creditPara);
					}

					try {
						if (busiTransVOs != null && busiTransVOs.length > 0) {
							for (int i = 0; i < busiTransVOs.length; ++i) {
								((ISaleOrderInterface) ((ISaleOrderInterface) busiTransVOs[i].getInfClass()))
										.afterDelete(inVO);
							}
						}
						SaleorderBVO[] saleorderBVOs = (SaleorderBVO[]) inVO.getChildrenVO();
						IOrderTotalInfo iorder = NCLocator.getInstance().lookup(IOrderTotalInfo.class);
						for (int i = 0; i < saleorderBVOs.length; i++) {
							//源头单据表体id
							String cfirstbillbid = saleorderBVOs[i].getCsourcebillbodyid();
							//实出数量
							UFDouble noutnum = saleorderBVOs[i].getNnumber();
							String sql = "select bdef8 from mmpac_order_in where 	pk_order_in = '"+cfirstbillbid+"'";
							Object bdef8 = (Object) iuap.executeQuery(sql, new ColumnProcessor());
							
							
							if(null==bdef8) {
								continue;
							}
							
							UFDouble result  = new UFDouble(bdef8.toString()).sub(noutnum);
							
							StringBuffer update = new StringBuffer();
							update.append(" update mmpac_order_in set");
							//如果生产总订单成品明细已执行数量已经为0，已执行数量直接给null.而不是0.00 避免显示误解
							if(result.doubleValue() == 0) {
								update.append(" bdef8 = null");
							}else {
								update.append(" bdef8 = '"+result+"'");
							}
							update.append(" where pk_order_in = '"+cfirstbillbid+"'");
							iorder.updateExecnum(update.toString());
						}
					} catch (Exception var20) {
						throw new BusinessException("二次开发外部接口 销售订单删除后操作出现问题！" + var20.getMessage(), var20.getCause());
					}
				} catch (Exception var22) {
					if (var22 instanceof BusinessException) {
						throw (BusinessException) var22;
					}

					throw new BusinessException(var22.getMessage());
				}

				inVO = null;
				pk_bill = null;
				billtype = null;
				return retObj;
			}
		} catch (Exception var23) {
			if (var23 instanceof BusinessException) {
				throw (BusinessException) var23;
			} else {
				throw new PFBusinessException(var23.getMessage(), var23);
			}
		}
	}

	public String getCodeRemark() {
		return "\t// ####本脚本必须含有返回值,返回DLG和PNL的组件不允许有返回值####\n// *************从平台取得由该动作传入的入口参数。***********\nObject inObject = getVo();\n// 1,首先检查传入参数类型是否合法，是否为空。\nif (!(inObject instanceof nc.vo.so.so001.SaleOrderVO))\n\tthrow new nc.vo.pub.BusinessException(\n\t\t\t\t\tnc.bs.ml.NCLangResOnserver.getInstance()\n\t\t\t\t\t\t\t.getStrByID(\"sopub\", \"UPPsopub-000258\"));\nif (inObject == null)\n\tthrow new nc.vo.pub.BusinessException(\n\t\t\t\t\tnc.bs.ml.NCLangResOnserver.getInstance()\n\t\t\t\t\t\t\t.getStrByID(\"sopub\", \"UPPsopub-000259\"));\n// 2,数据合法，把数据转换。\nnc.vo.so.so001.SaleOrderVO inVO = (nc.vo.so.so001.SaleOrderVO) inObject;\nString pk_bill = ((nc.vo.so.so001.SaleorderHVO) inVO.getParentVO())\n\t\t.getCsaleid();\nString billtype = ((nc.vo.so.so001.SaleorderHVO) inVO.getParentVO())\n\t\t.getCreceipttype();\n// 3,获取仅包含本销售公司发货行的销售订单vo。\n// nc.vo.so.so001.SaleOrderVO selfVO = inVO.getOrdVOOfSaleCorp();\ninObject = null;\nInteger iAct = new Integer(\n\t\tnc.vo.so.so001.ISaleOrderAction.A_BLANKOUT);\nsetParameter(\"iAction\", iAct);\n// **************************************************************************************************\nsetParameter(\"INVO\", inVO);\nsetParameter(\"PKBILL\", pk_bill);\nsetParameter(\"BILLTYPE\", billtype);\n// **************************************************************************************************\nObject retObj = null;\n// 方法说明:加锁\nrunClassCom@\"nc.impl.scm.so.pub.DataControlDMO\", \"lockPkForVo\", \"&INVO:nc.vo.pub.AggregatedValueObject\"@;\nif (retObj != null) {\n\tm_methodReturnHas.put(\"lockPkForVo\", retObj);\n}\n// ##################################################\ntry {\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:并发检查\n\trunClassCom@\"nc.impl.scm.so.pub.ParallelCheckDMO\", \"checkVoNoChanged\", \"&INVO:nc.vo.pub.AggregatedValueObject\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"checkVoNoChanged\", retObj);\n\t}\n\t// ##################################################\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:并发互斥检查\n\tretObj = runClassCom@\"nc.impl.scm.so.pub.CheckStatusDMO\", \"isDelStatus\", \"&INVO:nc.vo.pub.AggregatedValueObject\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"isEditStatus\", retObj);\n\t}\n\t\n\t// ##################################################\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 调用信用____开始____(必须跟“调用信用____结束____”成对出现)\n\tnc.itf.uap.sf.ICreateCorpQueryService corpService = (nc.itf.uap.sf.ICreateCorpQueryService)nc.bs.framework.common.NCLocator.getInstance().lookup(nc.itf.uap.sf.ICreateCorpQueryService.class.getName());\n\tboolean creditEnabled = corpService.isEnabled(inVO.getPk_corp(), \"SO6\");\n\tObject creditObject = null;\n\tObject creditPara = null;\n\tif (creditEnabled) {\n\t\t// 注意：此处不能采用runClassCom的方式进行调用\n\t\tnc.itf.so.so120.IBillInvokeCreditManager creditManager = (nc.itf.so.so120.IBillInvokeCreditManager) nc.bs.framework.common.NCLocator\n\t\t\t\t.getInstance().lookup(nc.itf.so.so120.IBillInvokeCreditManager.class.getName());\n\t\tnc.vo.so.credit.SOCreditPara para = new nc.vo.so.credit.SOCreditPara(new String[] { inVO.getPrimaryKey() }, null,\n\t\t\t\tnc.vo.scm.pub.bill.CreditConst.ICREDIT_ACT_DEL, new String[] { inVO.getBizTypeid() }, inVO.getPk_corp(),\n\t\t\t\tcreditManager);\n\t\tcreditObject = creditManager;\n\t\tcreditPara = para;\n\t\tcreditManager.renovateARByHidsBegin(para);\n\t}\n\t// ##################################################\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:可用量接口\n\t\n\tInteger istatus = (Integer) inVO.getParentVO()\n\t\t\t.getAttributeValue(\"fstatus\");\n\tnc.vo.so.so001.SaleOrderVO atpvo = inVO;\n\tArrayList listatpbefore = null;\n\t// 检查是否是审批未通过的单据\n\tif (istatus != null\n\t\t\t&& istatus.intValue() != nc.ui.pub.bill.BillStatus.NOPASS) {\n\t\tif (atpvo != null && atpvo.getBodyVOs() != null\n\t\t\t\t&& atpvo.getBodyVOs().length > 0) {\n\t\t\tsetParameter(\"ATPVO\", atpvo);\n\t\t\tlistatpbefore  = (ArrayList)runClassCom@\"nc.impl.so.sointerface.SOATP\", \"modifyATPBefore\", \"&ATPVO:nc.vo.pub.AggregatedValueObject\"@;\n\t\t}\n\t}\n\t\n\t// ##################################################\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:回写合同订货量\n\trunClassCom@\"nc.impl.scm.so.pub.OtherInterfaceDMO\", \"setSaleCT\", \"&INVO:nc.vo.pub.AggregatedValueObject\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"setSaleCT\", retObj);\n\t}\n\t// ##################################################\n    // 回写预订单状态\n\trunClassCom@\"nc.impl.scm.so.so001.SaleOrderDMO\", \"setPreOrdStatus\", \"&INVO:nc.vo.pub.AggregatedValueObject\"@;\n\t// *********返回结果******************************************************\n    // ##################################################\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:作废本单据\n\tretObj = runClassCom@\"nc.impl.scm.so.pub.BusinessControlDMO\", \"setBillBlankOut\", \"&PKBILL:String,&BILLTYPE:String\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"setBillBlankOut\", retObj);\n\t}\n\t// ##################################################\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:释放单据号\n\tretObj = runClassCom@\"nc.impl.scm.so.pub.CheckValueValidityImpl\", \"returnBillCodeNoNewTrans\", \"&INVO:nc.vo.pub.AggregatedValueObject\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"returnBillNo\", retObj);\n\t}\n\t// ##################################################\n\t// ************************把销售订单置入参数表。**************************************************\n\t// **************************************************************************************************\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:作废时更新订单核销关系\n\tretObj = runClassCom@\"nc.impl.scm.so.so016.BalanceDMO\", \"updateSoBalanceWhenOrdBlankout\", \"&INVO:nc.vo.so.so001.SaleOrderVO\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"updateSoBalanceWhenOrdBlankout\", retObj);\n\t}\n\t// ##################################################\n\t// *********返回结果******************************************************\n\t// ##################################################\n\t// 回写退货数量\n\trunClassCom@\"nc.impl.scm.so.so001.SaleOrderDMO\", \"setRetNum\", \"&INVO:nc.vo.so.so001.SaleOrderVO\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"setRetNum\", retObj);\n\t}\n\t// ##################################################\n\t// ##################################################\n\t// 缺货登记\n\trunClassCom@\"nc.impl.scm.so.so008.OosinfoDMO\", \"blankFromOrder\", \"&INVO:nc.vo.so.so001.SaleOrderVO\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"blankFromOrder\", retObj);\n\t}\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// ##################################################\n\t// ####重要说明：生成的业务组件方法尽量不要进行修改####\n\t// 方法说明:ATP\n\t\n\tif (istatus != null\n\t\t\t&& istatus.intValue() != nc.ui.pub.bill.BillStatus.NOPASS) {\n\t\tif (atpvo != null && atpvo.getBodyVOs() != null\n\t\t\t\t&& atpvo.getBodyVOs().length > 0) {\n\t\t\tsetParameter(\"LISTATPBEFORE\", listatpbefore);\n\t\t\trunClassCom@\"nc.impl.so.sointerface.SOATP\", \"modifyATPAfter\", \"&ATPVO:nc.vo.pub.AggregatedValueObject,&LISTATPBEFORE:java.util.ArrayList\"@;\n\t\t}\n\t}\n\t\n\t// ##################################################\n\t// 记录日志\n\tString sActionMsg = \"单据号为: \"+inVO.getHeadVO().getVreceiptcode()+\" 的销售订单删除成功!\";\n\tsetParameter(\"ACTIONMSG\", sActionMsg);\n\trunClassCom@\"nc.impl.scm.so.pub.DataControlDMO\", \"insertBusinesslog\", \"&INVO:nc.vo.pub.AggregatedValueObject,&ACTIONMSG:String,&BUTTONNAME:String,&OPERID:String,&USERDATE:String\"@;\n\tif (retObj != null) {\n\t\tm_methodReturnHas.put(\"insertBusinesslog\", retObj);\n\t}\n\t// ##################################################\n\t// 调用信用____结束____(必须跟“调用信用____开始____”成对出现)\n\tif (creditEnabled) {\n\t\tnc.itf.so.so120.IBillInvokeCreditManager creditManager = (nc.itf.so.so120.IBillInvokeCreditManager)creditObject;\n\t\tcreditManager.renovateARByHidsEnd((nc.vo.so.credit.SOCreditPara)creditPara);\n\t}\n} catch (Exception e) {\n\tif (e instanceof BusinessException)\n\t\tthrow (BusinessException) e;\n\tthrow new BusinessException(e.getMessage());\n} \n// *********返回结果******************************************************\ninVO = null;\npk_bill = null;\nbilltype = null;\nreturn retObj;\n// ************************************************************************\n";
	}

	private void setParameter(String key, Object val) {
		if (this.m_keyHas == null) {
			this.m_keyHas = new Hashtable();
		}

		if (val != null) {
			this.m_keyHas.put(key, val);
		}

	}

	private void reWritePO(String[] poID, boolean isReferred) throws Exception {
		String opid = InvocationInfoProxy.getInstance().getUserCode();
		IOrder bo = (IOrder) NCLocator.getInstance().lookup(IOrder.class.getName());
		bo.updateCoopFlag(isReferred, poID, (String) null, (String[]) null, opid);
	}
}